Prime path(BFS)

题目:

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 

1033 
1733 
3733 
3739 
3779 
8779 
8179

The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input:

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output:

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0


题意:

给你两个数a,b,让你从a变得b每次只转化一个位置上的数,且转化的数,必须是素数。求最后能够到达b的最小转化次数。不能到达b就输出“Impossible”。

思路:

这道题也是搜索,从a搜索到b,找到每次只转化一位数的数,判断是否是素数,如果是就入列。最后就输出到达b时的最小次数。当然a可以大于b,也可以小于等于b,当a小于b时,那就不能只向比它大的数搜。正好这个数总是四位数,那么我们可以从个位,十位,百位,以及千位从1~9开始搜,那么就每次只转化一位数,再判断它是否是素数。

#include<iostream>
#include<stdio.h>
#include<queue>
#include<algorithm>
#include<string.h>
#include<cmath>
#define maxn 1000010
using namespace std;
struct node
{
    int va;
    int num;
};
int n,m,vis[10000],x[4];
node start,nextt;
bool com(int k)//判断是否是素数;
{
    if(k==2)//2是最小的素数,先提出来;
        return true;
    if(k==1||k%2==0)//1不是素数;
        return false;
    int ki=(int)sqrt(k);
    for(int i=3;i<=ki;i+=2)
    {
        if(k%i==0)
            return false;
    }
    return true;
}
void bfs()
{
    queue<node>q;
    start.va=n;
    start.num=0;
    q.push(start);
    while(!q.empty())
    {
        start=q.front();
        q.pop();
        for(int i=1; i<=9; i+=2)//个位中以偶数结尾的数都不是素数;
        {
            nextt=start;
            nextt.va=nextt.va/10*10+i;//虽然我们是个位变,但是最终的结果还是必须整合起来,之前我就是先把每个位提取出来在转化,但是这样太麻烦,因为这样你起码在每个位当中都得重新计算一遍。
            if(nextt.va==m)
            {
                cout<<nextt.num+1<<endl;
                return;
            }
            if(com(nextt.va)&&!vis[nextt.va])
            {
                vis[nextt.va]=1;
                nextt.num+=1;
                q.push(nextt);
            }
        }

        for(int i=0; i<=9; i++)//十位
        {
            nextt=start;
            nextt.va=(nextt.va/100*10+i)*10+nextt.va%10;
            if(nextt.va==m)
            {
                cout<<nextt.num+1<<endl;
                return;
            }
            if(com(nextt.va)&&!vis[nextt.va])
            {
                vis[nextt.va]=1;
                nextt.num+=1;
                q.push(nextt);
            }
        }
        for(int i=0; i<=9; i++)//百位
        {
            nextt=start;
            nextt.va=(nextt.va/1000*10+i)*100+nextt.va%100;
            if(nextt.va==m)
            {
                cout<<nextt.num+1<<endl;
                return;
            }
            if(com(nextt.va)&&!vis[nextt.va])
            {
                vis[nextt.va]=1;
                nextt.num+=1;
                q.push(nextt);
            }
        }
        for(int i=1; i<=9; i++)//千位不能从0开始
        {
            nextt=start;
            nextt.va=nextt.va%1000+i*1000;
            if(nextt.va==m)
            {
                cout<<nextt.num+1<<endl;
                return;
            }
            if(com(nextt.va)&&!vis[nextt.va])
            {
                vis[nextt.va]=1;
                nextt.num+=1;
                q.push(nextt);
            }
        }
    }
    cout<<"Impossible"<<endl;
}
    int main()
    {
        int T;
        cin>>T;
        while(T--)
        {
            cin>>n>>m;
            memset(vis,0,sizeof(vis));
            vis[n]=1;
            if(n==m)
                cout<<0<<endl;
            else
                bfs();
        }
    }

 

  • 1
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值